int led = 13;

int taste = A2;
int tastenZustand = 0;
int ledZustand = -1; // 1 = led an, -1 = led aus

int poti = A0;                  // Der Drehregler
int potiWert = 0;               // Werte zwischen 0 und 1023
int potiLow = 1023;
int potiHigh = 0;

void setup() {
  pinMode (led, OUTPUT);
  Serial.begin(9600);
}

void loop() {

  tastenZustand = digitalRead(taste);
  // immer wenn taste gedrück wurde, ändert sich ledZustand…
  if (tastenZustand == HIGH) {
    // bei jedem Betätigen der Taste wird der ledZustand getoggelt
    ledZustand = -ledZustand;
  }

  // folgende Sachen sollen nur ausgeführt werden, wenn der ledZustand "1" ist
  if (ledZustand == 1) {
    aktivRoutine();
  }

  Serial.print("ledZustand: ");
  Serial.println(ledZustand);

  delay(200);
}

void aktivRoutine() {
  // Werte des Potentiometers werden in die Variable "potiWert" eingelesen
  potiWert = analogRead(poti);  //Drehregler (Poti) zwischen 0 und 1023

  // blink-Ablauf
  digitalWrite (led, HIGH);
  delay (potiWert);
  digitalWrite (led, LOW);
  delay (potiWert);

  Serial.print("potiWert: ");
  Serial.println(potiWert);

  // ================= piezo-Element ===============

  // Code angepasst von "Light Theremin – ein schauriges Musikinstrument"
  // 50 - 4000 = Range of Frequency of Piezo
  // map überträgt die Sensor-Werte auf die Range der Frequency

  int pitch = map(potiWert, potiLow, potiHigh, 50, 4000);

  // Ton an Pin8, 20 Millisekunden Länge
  tone(8, pitch, 20);
}
